import 'package:flutter_test/flutter_test.dart';
import 'package:rook_sdk_health_connect/src/data/mapper/permission_mappers.dart';
import 'package:rook_sdk_health_connect/src/data/proto/protos.pbenum.dart';
import 'package:rook_sdk_health_connect/src/domain/enums/health_permission.dart';

void main() {
  group('HealthPermission to HealthPermissionProto mappers', () {
    test(
      'GIVEN a HCPermission.sleep WHEN toProto THEN return PermissionProto.SLEEP',
      () {
        const permission = HealthPermission.sleep;

        final result = permission.toProto();

        expect(result, HealthPermissionProto.SLEEP);
      },
    );

    test(
      'GIVEN a HCPermission.body WHEN toProto THEN return PermissionProto.BODY',
      () {
        const permission = HealthPermission.body;

        final result = permission.toProto();

        expect(result, HealthPermissionProto.BODY);
      },
    );

    test(
      'GIVEN a HCPermission.physical WHEN toProto THEN return PermissionProto.PHYSICAL',
      () {
        const permission = HealthPermission.physical;

        final result = permission.toProto();

        expect(result, HealthPermissionProto.PHYSICAL);
      },
    );

    test(
      'GIVEN a HCPermission.all WHEN toProto THEN return PermissionProto.ALL',
      () {
        const permission = HealthPermission.all;

        final result = permission.toProto();

        expect(result, HealthPermissionProto.ALL);
      },
    );
  });
}
